package org.mirlab.AudioFingerprinting;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.URLEncoder;

import android.app.Activity;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.util.Base64;
import org.mirlab.record.myWavRecorder;


public class AudioFingerprintingActivity extends Activity {
	//String queryURL="http://140.114.85.80:8080/afpCuda/saveWav_for_android_rc.php";
	//String queryURL = "http://140.114.88.80:8080/afpFarmer2550/saveWav_for_android.php";
	//String queryURL = "http://140.114.88.80:8080/afpCuda/saveWav_for_android.php";
	String queryURL = "http://140.112.91.63:8080/demo/afpCuda/saveWav_for_android.php";
	//String queryURL = "http://192.168.0.100/saveWav.php";
	String sdDir = Environment.getExternalStorageDirectory().getAbsolutePath();
	String projectPath = sdDir + "/mirlab/AudioFingerprinting";
	String wavFilePath = projectPath + "/rec.wav";
	File wavFile;
	
	WebView wv;
	TextView tv;
	ProgressBar pgb;
	Button recordBtn, playBtn;
	int recordDuration = 8;
	int progressCount = 0;
	myWavRecorder recorderInstance;
	Thread recordThread, playThread, recogThread;
	
	protected static final int RECORDING = 101;
	protected static final int REC_FINISH = 102;
	protected static final int RECOG = 103;
	protected static final int RECOG_FINISH = 104;
	protected static final int PLAY = 105;
	protected static final int PLAY_FINISH = 106;
	
	OnClickListener btnListener = new OnClickListener() {
		@Override
		public void onClick(View v) {
			// TODO Auto-generated method stub
			if (v.getId() == R.id.record) {
				pgb.setMax(recordDuration * 10);
		        pgb.setProgress(0);
				recordBtn.setEnabled(false);
				playBtn.setEnabled(false);
				recordThread = new Thread(new RecordThread());
				recordThread.start();
			} 
			if (v.getId() == R.id.play) {
				if (wavFile.exists()) {
					Message m = new Message();
					m.what=PLAY;
					myMessageHandler.sendMessage(m);
					recordBtn.setEnabled(false);
					playBtn.setEnabled(false);
					playThread = new Thread(new PlayThread());
					playThread.start();
				} else {
					tv.setText("|");
				}
			}
		}
	};
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.landscape);
        
        try {
        	if(!new File(sdDir+"/mirlab").exists()) {
	        	new File(sdDir+"/mirlab").mkdir();
	        	Log.i("AudioFingerprinting","Create " + sdDir.toString());
	        }
	        if(!new File(sdDir + "/mirlab/AudioFingerprinting").exists()){
	        	new File(sdDir + "/mirlab/AudioFingerprinting").mkdir();
	        	Log.i("AudioFingerprinting","create AudioFingerprinting DIR");
	        }
        } catch (Exception e) {
        	
        }
        
        
        wv = (WebView) findViewById(R.id.wv);
        tv = (TextView) findViewById(R.id.tv);
        pgb = (ProgressBar) findViewById(R.id.pgb);
        recordBtn = (Button) findViewById(R.id.record);
        playBtn = (Button) findViewById(R.id.play);
        
        recordBtn.setOnClickListener(btnListener);
        playBtn.setOnClickListener(btnListener);
        
        pgb.setMax(recordDuration * 10);
        pgb.setProgress(0);
        
        wavFile = new File(wavFilePath);
        if (wavFile.exists()) {wavFile.delete();}
    }
    
    Handler myMessageHandler = new Handler(){
		public void handleMessage(Message msg){
			switch(msg.what){
				case RECORDING:
					if(!recordThread.isInterrupted()){
						pgb.setProgress(progressCount);
						tv.setText("...");
					}
					break;
				case REC_FINISH:
					recordThread.interrupt();
					recordThread = null;
					//recorderInstance.setRecording(false);
					pgb.setProgress(0);
					tv.setText("...");
					recordBtn.setEnabled(true);
					playBtn.setEnabled(true);
					Message m = new Message();
	        		m.what=RECOG;
	        		myMessageHandler.sendMessage(m);
	        		recogThread = new Thread(new RecogThread());
	        		recogThread.start();
					break;
				case PLAY:
					if(!playThread.isInterrupted()){
						tv.setText("...");
					}
					break;
				case PLAY_FINISH:
					playThread.interrupt();
					playThread = null;
					recordBtn.setEnabled(true);
					playBtn.setEnabled(true);
					tv.setText("񧹲I");
					break;
				case RECOG:
					if(!recogThread.isInterrupted()){
						tv.setText("Ѥ...");
					}
					break;
				case RECOG_FINISH:
					tv.setText("ѧI");
					recogThread.interrupt();
					recogThread = null;
					break;
			}
			super.handleMessage(msg);
		}
	};
    
	public void goRecog() {
		// TODO Auto-generated method stub
		//File f = new File(wavFile);
		try {
			Thread.sleep(3000);
			while(!wavFile.exists()) {wavFile = new File(wavFilePath);}
			InputStream is = new FileInputStream(wavFile);
			byte buf[] = new byte[is.available()];
			is.read(buf);
			Log.i("AudioFingerprint", ""+is.available());

			String postData = "waveBase64=" + URLEncoder.encode(Base64.encodeToString(buf, 0));
			is.close();
			wv.postUrl(queryURL,  postData.getBytes());
			Log.i("AudioFingerprint", "Send data");
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
    
    class RecordThread implements Runnable {
		@Override
		public void run() {
			// TODO Auto-generated method stub
			wv.loadUrl(null);
			recorderInstance = new myWavRecorder();
			Thread th = new Thread(recorderInstance);
			recorderInstance.setwaveFileName(wavFile);
			recorderInstance.setRecording(true); 
			th.start();
			for (int i = 0; i < (recordDuration * 10); i++) {
				try{
					progressCount=i+1;
					Thread.sleep(100);
					if(i==(recordDuration * 10 - 1)){
						Message m = new Message();
						m.what=REC_FINISH;
						myMessageHandler.sendMessage(m);
					} else {
						Message m = new Message();
						m.what=RECORDING;
						myMessageHandler.sendMessage(m);
					}
				} catch(Exception e) {
					e.printStackTrace();
				}
			}
			recorderInstance.setRecording(false);
		}
    }
    
    class PlayThread implements Runnable {
    	@Override
    	public void run() {
    		// TODO Auto-generated method stub
    		try {
    			MediaPlayer mMediaPlayer = new MediaPlayer();
    			mMediaPlayer.setDataSource(wavFilePath); 
        		mMediaPlayer.prepare(); 
        		mMediaPlayer.start();
        		//button|ݪPBʧ@
                synchronized (this) {
                    try {
                    	this.wait(recordDuration * 1000);
                    } catch (InterruptedException e) {
                    	e.printStackTrace();
                    }
                }
    		} catch (Exception e) {
    			e.printStackTrace();
    		}
    		Message m = new Message();
			m.what=PLAY_FINISH;
			myMessageHandler.sendMessage(m);
    	}
    }
    
    class RecogThread implements Runnable {
		@Override
		public void run() {
			goRecog();
			Message m = new Message();
			m.what=RECOG_FINISH;
			myMessageHandler.sendMessage(m);
		}
    }
}